'****************************************************************
'*  Name    : Test1_DS1307.BAS                                  *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2016 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 13/03/2016                                        *
'*  Version : 1.0                                               *
'*  Notes   : This demo could check the DS1307 I2C RTC chip     *
'*          : The code is prepared to use the 24LC256.inc file  *
'****************************************************************
'
'===============================================================================
' This source code is free software and provided 'as is', any express or implied 
' warranties are disclaimed. you can redistribute it and/or modify.
' The author is not responsible of the use of this software.
' This program is distributed in the hope that it will be useful, but WITHOUT 
' ANY WARRANTY. However, a mention of the author and compiler would be appreciated.
'*******************************************************************************
' Este cdigo fuente es un software libre, puede redistribuirlo y/o modificarlo.
' El autor no se hace responsable del uso de este software.
' Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador
' sera muy apreciado.
'*******************************************************************************
' Ce code source est un logiciel libre, vous pouvez le redistribuer et/ou modifier.
' L'auteur n'est pas responsable de l'utilisation de ce logiciel.
' Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE.
' Cependant mentionner l'auteur et le compileur serait trs aprci.
'===============================================================================
'
' Uncomment the next line to disable the NACK function.
'$define _DisableNACK_

' Uncomment the next line to enable the interrupts protection.
'$define _EnableGIE_Save_

' Uncomment the next line to enable the LCD for this project.
$define _LCD_

$define _Test1_DS1307_bas_
'-------------------------------------------------------------------------------
' To see the result of compilation please see the asm code.
$ifdef _EnableGIE_Save_
@#define __INTERRUPTS_ENABLED 1
$endif
'-------------------------------------------------------------------------------
    $define _DisableHserial_
'    Include "D:/MyIncFiles/Amicus18_25K20.inc"
    Include "Amicus18_25K20.inc"    

'    Declare Create_Coff = On
'    Declare Watchdog = Off
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = Off
'    Declare Create_Coff = On
'    Declare Bootloader = Off
'    Declare Show_System_Variables = On
'    Declare MemWrite_Int_Control = 1
'===============================================================================
$ifdef _LCD_
' Configuration of the AMI18 LCD Shield for the AMicus18 Board.
    Declare LCD_DTPin = PORTB.4         ' LCD's Data lines (D4 to D7)
    Declare LCD_ENPin = PORTB.3         ' LCD's EN line
    Declare LCD_RSPin = PORTB.2         ' LCD's RS line
    Declare LCD_Interface = 4           ' 4-bit interface to LCD
    Declare LCD_Lines = 2               ' LCD contains 2 lines
    Declare LCD_DataUs = 50             ' Time to wait after print a data To LCD
    Declare LCD_CommandUs = 2000        ' Time to wait after print a command to LCD
    Declare LCD_Type = Alphanumeric     ' LCD type is alphanumeric
    Symbol __LCD_CharsLenght = 16       ' For the AMI18 LCD Shield
    Symbol LCD_CharsLenght = 16         ' For the AMI18 LCD Shield
$endif
'------------------------------------------------------------------------------- 
' Uncomment a line to define a Terminal Baud Rate, and compile. (One only)
'    $define _9600B_
'    $define _19200B_    
    $define _38400B_
'    $define _57600B_ 

    $ifdef _9600B_
    'Calculated Baudrate = 9598 @ Xtal 64MHz, Error = -0,02%
    Declare Hserial_RCSTA  = %10010000  ' Enable continuous receive 
    Declare Hserial_TXSTA  = %00100100  ' Enable transmit, BRGH = 1
    Declare Hserial_Clear  = On         ' Clear overflow automatically
    Declare Hserial_SPBRG  = $82        ' Baud Rate Generator Low Byte Value
    SPBRGH    = $06                     ' Baud Rate Generator High Byte Value
    BAUDCON.3 = 1                       ' Enable the 16 bit Baud Rate Generator  
    $endif

    $ifdef _19200B_
    Declare Hserial_Baud = 19200        ' Set baud rate to 19200
    Declare Hserial_RCSTA = %10010000   ' Enable serial port and continuous receive
    Declare Hserial_TXSTA = %00100100   ' Enable transmit and asynchronous mode
    Declare Hserial_Clear = On          ' Enable Error clearing on received characters
    $endif

    $ifdef _38400B_
    Declare Hserial_Baud = 38400        ' Set baud rate to 38400
    Declare Hserial_RCSTA = %10010000   ' Enable serial port and continuous receive
    Declare Hserial_TXSTA = %00100100   ' Enable transmit and asynchronous mode
    Declare Hserial_Clear = On          ' Enable Error clearing on received characters
    $endif

    $ifdef _57600B_
    Declare Hserial_Baud = 57600        ' Set baud rate to 57600
    Declare Hserial_RCSTA = %10010000   ' Enable serial port and continuous receive
    Declare Hserial_TXSTA = %00100100   ' Enable transmit and asynchronous mode
    Declare Hserial_Clear = On          ' Enable Error clearing on received characters
    $endif
'===============================================================================
' Bits definition of the PIC18F25K20 SFRs.
'
'    Include "D:/MyIncFiles/SYS_18FXXK20.inc"
    Include "SYS_18FXXK20.inc"
'===============================================================================            
' Global Flags
    Dim SM_AllFlags As Byte System
    Dim EverySecondFlag As SM_AllFlags.0
    Dim EveryMinuteFlag As SM_AllFlags.1
    Dim ReturnACK As Byte
    Dim RTC_Minute_Old As Byte
    Dim Humidity As Byte
    Dim bCounter As Byte
'===============================================================================
' One language must be validated for the DS1307 RTC.
' Define the language. 
'    $define _Spanish_
    $define _English_
'    $define _French_ 
'===============================================================================
' Send the Version File to the Terminal
'    Include "D:/MyIncFiles/VersionFile.Inc"
    Include "VersionFile.inc"
'-------------------------------------------------------------------------------
' Definition of the LCD Board
'    Include "D:/MyIncFiles/LCD_AMI18_Board.inc"
    Include "LCD_AMI18_Board.inc"
'-------------------------------------------------------------------------------
'   Hardware I2C pins
    Declare SDA_Pin = PORTC.4           ' SDA connected to this pin
    Declare SCL_Pin = PORTC.3           ' SCL connected to this pin
    Declare Hbus_Bitrate 100            ' Bus frequency 100kHz to 1000 Khz
    Declare Slow_Bus = On     

' Library for the DS1307 Clock Calendar.  
'    Include "D:/MyIncFiles/DS1307-H.inc"    ' I2C Harware of the PIC (HBusOut/HBusIn) with ACK control.
    Include "DS1307-H.inc"

'    Include "D:/MyIncFiles/DS1307-S.inc"    ' I2C Software of the PIC (BusOut/BusIn) with ACK control.
'    Include "DS1307-S.inc"
'===============================================================================
AMICUS_START:
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
    F_SWDTEN = 0            ' Sure, disable the Watchdog
    INTCON = 0              ' Disable all interrupts
    PORTA = 0               ' Clear all ports
    LATA = 0
    PORTB = 0
    LATB = 0    
    PORTC = 0
    LATC = 0

    ' Clear the LCD_BackLight.
    $ifdef _LCD_
    Low LCD_Backlight
    $endif
'===============================================================================
    F_NOT_RBPU = 1          ' Internal resistors pullups disabled.
    WPUB = 0                ' Internal resistors pullups disabled in PORTB
    '
    'Enable only the High Interrupts mode.
    F_IPEN = 0              ' RCON register.
    SM_AllFlags = 0         ' Clear all flags to begin.
    '
    ' Function: Define others project registers.
    EECON1 = 0              ' Clear all registers used for the eeprom acces.
    EECON2 = 0
    EEDATA = 0
    EEADR = 0            
    '
    DelayMS 250
    $ifdef _LCD_
    Cls    
    $endif
'===============================================================================
AMICUS_MAIN:
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
    ' Send all version files to the terminal.
$ifdef _HRSOutVersionFile_inc_
    $ifdef _Test1_DS1307_bas_
    HRSOutVersionFile(_Test1_DS1307_bas_Version)
    $endif
    $ifdef _LCD_AMI18_Board_inc_
    HRSOutVersionFile(_LCD_AMI18_Board_inc_Version)
    $endif
    $ifdef _TC74H_INC_
    HRSOutVersionFile(_TC74H_INC_Version)
    $endif
    $ifdef _24LC256_inc_
    HRSOutVersionFile(_24LC256_inc_Version)
    $endif  
    $ifdef _DS1307_INC_
    HRSOutVersionFile(_DS1307_INC_Version)
    $endif
    HRSOut CR
$endif
'-------------------------------------------------------------------------------
    HRSOut "Test1_DS1307.bas file", CR
    HRSOut "Testing the DS1307 Clock Calendar", CR
    HRSOut "Sending Date & Time every minute to the terminal.", CR    
    HRSOut "The Hserial Baud Rate is set to "  
    $ifdef _9600B_
    HRSOut "9600"
    $endif
    $ifdef _19200B_
    HRSOut "19200"
    $endif
    $ifdef _9600B_
    HRSOut "9600"
    $endif        
    $ifdef _38400B_
    HRSOut "38400"
    $endif
    $ifdef _57600B_
    HRSOut "57600"
    $endif
    HRSOut CR        

    ' Check the the DS1307 ackknowledge.
    ' Check it the DS1307 Clock Calendar is connected?
    ' Only check value = 0, other values could be = 1 to 255.
    DS1307_Present(ReturnACK)
    If ReturnACK = 0 Then
        HRSOut "The DS1307 Device is ready!", CR
    Else
        HRSOut "NACK DS1307 RTC device!", CR
        Stop        ' The program demo cannot run.
    EndIf  
    HRSOut CR
    '---------------------------------------------------------------------------
' Code for configuring the DS1307. Only write it once to PIC. 
' If the RTC have a Battery only, compile again without this lines & write to the PIC again.
'
    ' Config Time and Date to the clock calendar.
'    DS1307_WriteDate(1, 6, 3, 16, ReturnACK)  ' Write an initial date
'    If ReturnACK = 1 Then
'        HRSOut "NACK DS1307 Write Date", CR
'    EndIf

'    DS1307_WriteTime(20, 57, 00, ReturnACK)     ' Write an initial time
'    If ReturnACK = 1 Then
'        HRSOut "NACK DS1307 Write Time", CR
'    EndIf
    '---------------------------------------------------------------------------
    ' Write to the Config register: Enable signal output with frequency = 1 Hz.
    DS1307_WriteControl(%10010000, ReturnACK)
    If ReturnACK = 1 Then
        HRSOut "NACK DS1307 Write Control", CR
    EndIf
    $ifdef _LCD_
    High LCD_Backlight              ' Set the Backlight to see the value on the LCD.
    $endif
    RTC_Minute_Old = 0
'===============================================================================
' MAIN program: Read the Time every second & Read the date every minute.
' Set the Backlight On 3 Sec every minute to see the Time & Date on the LCD.

    While 1 = 1
        #ifdef WatchDog_Req
        Clrwdt
        #endif 
        DS1307_ReadTime(ReturnACK)                         ' Read the time from the DS1307
        If ReturnACK = 1 Then
            HRSOut "NACK DS1307 Read Time", CR
        EndIf
    
        ' Write the Date every minute only
        If RTC_Minute <> RTC_Minute_Old Then
            High LCD_Backlight                             ' Set the Backlight to see the value on the LCD.
            bCounter = 3                                   ' Backlight Set for 3 sec
    
            ' Write the Date to test only
            DS1307_ReadDate(ReturnACK)                     ' Read the date from the DS1307
            If ReturnACK = 1 Then
                HRSOut "NACK DS1307 Read Date", CR
            EndIf
            DS1307_Get_DayName(RTC_DayOfWeek, RTC_DayName) ' Get the day's name into string RTC_DayName
            DS1307_Get_MonthName(RTC_Month, RTC_MonthName) ' Get the months's name into string RTC_MonthName
        
            HRSOut "Date = ", RTC_DayName, " ",_        ' \
                              Dec2 RTC_Day, "/",_       ' | Serially transmit the date as ASCII
                              Dec2 RTC_Month,_          ' |
                              "/20", Dec RTC_Year, CR   ' /
        
            HRSOut "Time = ", Dec2 RTC_Hour, ":",_      ' \
                              Dec2 RTC_Minute, ":",_    ' | Serially transmit the time as ASCII
                              Dec2 RTC_Second, CR       ' /
            HRSOut CR
            RTC_Minute_Old =  RTC_Minute                ' Save the new minute value.
        EndIf    

        ' Print the Date to the LCD.
        $ifdef _LCD_
        CLL(1)                                      ' Erase line 1 of the LCD
        Print At 1,1, Str RTC_DayName\5, " ", Dec2 RTC_Day, "/", Dec2 RTC_Month, "/20", Dec RTC_Year
        $endif
        ' Print the Time to the LCD.
        $ifdef _LCD_
        CLL(2)                                          ' Erase line 2 of the LCD
        Print At 2,1, Dec2 RTC_Hour, ":", Dec2 RTC_Minute, ":", Dec2 RTC_Second    
        Print At 2,10, Str RTC_MonthName\7 
        $endif    

        ' Delay for the Backlight (3 Sec).
        If bCounter > 0 Then                
            Dec bCounter                                ' Decrement the Backlight counter every second.
            If bCounter = 0 Then
                Low LCD_Backlight
            EndIf
        EndIf    
      
        DelayMS 998 
    Wend
'===============================================================================
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
$ifdef _HRSOutVersionFile_inc_
_Test1_DS1307_bas_Version: CData "Test1_DS1307.bas Version 1.0 - 15/03/2016",0
$endif
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
    
