'****************************************************************
'*  Name    : Test2_DS1307.BAS                                  *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2016 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 13/03/2016                                        *
'*  Version : 1.0                                               *
'*  Notes   : This demo could check the DS1307 I2C RTC chip     *
'*          : Including some example with the 24LC256.inc file  *
'* Caution  : The TC74 temperature sensor pass to standby mode  *
'*          : because the Bus communications with others chips. *
'*          : It is necessary to send a NormalMode command      *
'*          : before reading the temperature (need time > 250mS)*
'****************************************************************
'
'===============================================================================
' This source code is free software and provided 'as is', any express or implied 
' warranties are disclaimed. you can redistribute it and/or modify.
' The author is not responsible of the use of this software.
' This program is distributed in the hope that it will be useful, but WITHOUT 
' ANY WARRANTY. However, a mention of the author and compiler would be appreciated.
'*******************************************************************************
' Este cdigo fuente es un software libre, puede redistribuirlo y/o modificarlo.
' El autor no se hace responsable del uso de este software.
' Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador
' sera muy apreciado.
'*******************************************************************************
' Ce code source est un logiciel libre, vous pouvez le redistribuer et/ou modifier.
' L'auteur n'est pas responsable de l'utilisation de ce logiciel.
' Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE.
' Cependant mentionner l'auteur et le compileur serait trs aprci.
'===============================================================================
'
' Uncomment the next line to disable the NACK function.
'$define _DisableNACK_

' Uncomment the next line to enable the interrupts protection.
'$define _EnableGIE_Save_

' Uncomment the next line to enable the LCD for this project.
$define _LCD_

$define _Test1_DS1307_bas_
'-------------------------------------------------------------------------------
' To see the result of compilation, please see the asm code.
$ifdef _EnableGIE_Save_
@#define __INTERRUPTS_ENABLED 1
$endif
'-------------------------------------------------------------------------------
    $define _DisableHserial_
'    Include "D:/MyIncFiles/Amicus18_25K20.inc"
    Include "Amicus18_25K20.inc"
'    Declare Create_Coff = On
'    Declare Watchdog = Off
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = Off
'    Declare Create_Coff = On
'    Declare Bootloader = Off
'    Declare Show_System_Variables = On
'    Declare MemWrite_Int_Control = 1
'===============================================================================
$ifdef _LCD_
' Configuration of the AMI18 LCD Shield for the AMicus18 Board.
    Declare LCD_DTPin = PORTB.4         ' LCD's Data lines (D4 to D7)
    Declare LCD_ENPin = PORTB.3         ' LCD's EN line
    Declare LCD_RSPin = PORTB.2         ' LCD's RS line
    Declare LCD_Interface = 4           ' 4-bit interface to LCD
    Declare LCD_Lines = 2               ' LCD contains 2 lines
    Declare LCD_DataUs = 50             ' Time to wait after print a data To LCD
    Declare LCD_CommandUs = 2000        ' Time to wait after print a command to LCD
    Declare LCD_Type = Alphanumeric     ' LCD type is alphanumeric
    Symbol __LCD_CharsLenght = 16       ' For the AMI18 LCD Shield
    Symbol LCD_CharsLenght = 16         ' For the AMI18 LCD Shield
$endif
'------------------------------------------------------------------------------- 
' Uncomment a line to define a Terminal Baud Rate, and compile. (One only)
'    $define _9600B_
'    $define _19200B_    
    $define _38400B_
'    $define _57600B_ 

    Declare Hserial_RCSTA  = %10010000  ' Enable continuous receive 
    Declare Hserial_TXSTA  = %00100100  ' Enable transmit, BRGH = 1
    Declare Hserial_Clear  = On         ' Clear overflow automatically
    
    $ifdef _9600B_
    'Calculated Baudrate = 9598 @ Xtal 64MHz, Error = -0,02%
    Declare Hserial_SPBRG  = $82        ' Baud Rate Generator Low Byte Value
    SPBRGH    = $06                     ' Baud Rate Generator High Byte Value
    BAUDCON.3 = 1                       ' Enable the 16 bit Baud Rate Generator  
    $endif
    $ifdef _19200B_
    Declare Hserial_Baud = 19200        ' Set baud rate to 19200
    $endif
    $ifdef _38400B_
    Declare Hserial_Baud = 38400        ' Set baud rate to 38400
    $endif
    $ifdef _57600B_
    Declare Hserial_Baud = 57600        ' Set baud rate to 57600
    $endif
'===============================================================================
' Variables for the project. 
    Dim ReturnACK As Byte
    Dim RTC_Minute_Old As Byte
    Dim bCounter As Byte
    Dim MinuteCounter As Byte
    Dim Contrast As Byte
   
    Dim Temperature As Byte
    Dim SensorAddress As Byte
    Dim Humidity As Byte
    Dim ReturnPolarity As Byte
    Dim nCharPos As Byte

    Dim MyDevice As Byte
    Dim MyDeviceList As Byte
    Dim E2P_Page As Word
    Dim LastE2P_Page As Word
    Dim E2P_PageList As Word
'===============================================================================
' One language must be validated for the DS1307 RTC.
' Define the language. 
'    $define _Spanish_
    $define _English_
'    $define _French_ 
'===============================================================================
' Send the Version File to the Terminal
'    Include "D:/MyIncFiles/VersionFile.Inc"
    Include "VersionFile.inc"
'-------------------------------------------------------------------------------
' Definition of the LCD Board
'    Include "D:/MyIncFiles/LCD_AMI18_Board.inc"
    Include "LCD_AMI18_Board.inc"
'-------------------------------------------------------------------------------
$ifdef _LCD_
'    Include "D:/MyIncFiles/LCD_ST7036.Inc"
$endif
'-------------------------------------------------------------------------------
' Definition of the I2C pins
    Declare SDA_Pin PORTC.4           ' SDA connected to this pin
    Declare SCL_Pin PORTC.3           ' SCL connected to this pin
    Declare Hbus_Bitrate 100          ' I2C Bus frequency 100kHz
    Declare Slow_Bus On     

' Library for the TC74 Temperature Sensor.  
    Include "TC74-H.inc"
'    Include "TC74-S.inc"

' Library for the 24LC256 external I2C eeprom memory.  
    Include "24LC256_H.inc"
'    Include "24LC256_S.inc"

' Library for the DS1307 Clock Calendar.  
    Include "DS1307-H.inc"    ' I2C Harware of the PIC (HBusOut/HBusIn) with ACK control.
'    Include "DS1307-S.inc"    ' I2C Software of the PIC (BusOut/BusIn) with ACK control.
'===============================================================================
AMICUS_START:
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
    WDTCON = 0              ' Sure, disable the Watchdog
    INTCON = 0              ' Disable all interrupts
    PORTA = 0               ' Clear all ports
    LATA = 0
    PORTB = 0
    LATB = 0    
    PORTC = 0
    LATC = 0

    ' Clear the LCD_BackLight.
    $ifdef _LCD_
    Low LCD_Backlight
    $endif
'===============================================================================
    INTCON2Bits_NOT_RBPU = 1  ' Internal resistors pullups disabled.
    WPUB = 0                  ' Internal resistors pullups disabled in PORTB
    '
    'Enable only the High Interrupts mode.
'    RCONBits_IPEN = 0       ' Interrupt Priority Enable bit
    '
    ' Function: Define others project registers.
    EECON1 = 0              ' Clear all registers used for the eeprom acces.
    EECON2 = 0
    EEDATA = 0
    EEADR = 0            
    '
    DelayMS 400
$ifdef _LCD_
    Cls    
    ' Test the contrast value in the PIC eeprom.
    $ifdef _ST7036_INC_
    Contrast = LCD_ReadContrast()         ' Read the current contrast value.
    If Contrast <> 8 Then
        LCD_WriteContrast(8)              ' Set the LCD contrast to 8. (5 to 15)
        LCD_SaveContrast()                ' Save this value into the PIC eeprom
    EndIf
    Contrast = LCD_ReadContrast()         ' Read the new contrast.
    $endif
$endif
'===============================================================================
AMICUS_MAIN:
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
    ' Send all files version to the terminal.
$ifdef _HRSOutVersionFile_inc_
    $ifdef _Test1_DS1307_bas_
    HRSOutVersionFile(_Test1_DS1307_bas_Version)
    $endif
    $ifdef _LCD_AMI18_Board_inc_
    HRSOutVersionFile(_LCD_AMI18_Board_inc_Version)
    $endif
    $ifdef _ST7036_INC_
    HRSOutVersionFile(_ST7036_INC_Version)
    $endif
    $ifdef _TC74H_INC_
    HRSOutVersionFile(_TC74H_INC_Version)
    $endif
    $ifdef _TC74S_INC_
    HRSOutVersionFile(_TC74S_INC_Version)
    $endif
    $ifdef _24LC256_inc_
    HRSOutVersionFile(_24LC256_inc_Version)
    $endif  
    $ifdef _DS1307_INC_
    HRSOutVersionFile(_DS1307_INC_Version)
    $endif
    HRSOut CR
$endif
'-------------------------------------------------------------------------------
    HRSOut "Test1_DS1307.bas file", CR
    HRSOut "Testing the DS1307 Clock Calendar with others peripherals.", CR
    HRSOut "Sending Date & Time every minute to the terminal.", CR    
    HRSOut "The Hserial Baud Rate is set to "  
    $ifdef _9600B_
    HRSOut "9600"
    $endif
    $ifdef _19200B_
    HRSOut "19200"
    $endif
    $ifdef _9600B_
    HRSOut "9600"
    $endif        
    $ifdef _38400B_
    HRSOut "38400"
    $endif
    $ifdef _57600B_
    HRSOut "57600"
    $endif
    HRSOut CR  
    $ifdef _ST7036_INC_
    HRSOut "Contrast value: ", Dec Contrast, CR
    $endif
    HRSOut CR      
'-------------------------------------------------------------------------------
    ' Check if the TC74 Temperature sensor is connected?
    ' The address must to be A4 in the ISIS model or real piece.
    ' Change the address if necessary. (TC74A0 to TC74A7)
    SensorAddress = TC74A4      
    TC74_Present(SensorAddress, ReturnACK)
    If ReturnACK = 0 Then
        HRSOut "The TC74 device is ready!", CR
    Else
        HRSOut "NACK TC74 sensor device!", CR
        Stop        ' The program demo cannot run.    
    EndIf
'-------------------------------------------------------------------------------
    ' Check the the DS1307 ackknowledge.
    ' Check if the DS1307 Clock Calendar is connected?
    ' Only check value = 0, other values could be = 1 to 255.
    DS1307_Present(ReturnACK)
    If ReturnACK = 0 Then
        HRSOut "The DS1307 Device is ready!", CR
    Else
        HRSOut "NACK DS1307 RTC device!", CR
        Stop        ' The program demo cannot run.
    EndIf  
    '---------------------------------------------------------------------------
    ' Code for configuring the DS1307. Only write it once to PIC. 
    ' If the RTC have a Battery only, compile again without this lines & write to the PIC.

    ' Config Time and Date to the clock calendar.
'    DS1307_WriteDate(1, 6, 3, 16, ReturnACK)  ' Write an initial date
'    If ReturnACK = 1 Then
'        HRSOut "NACK DS1307 Write Date", CR
'    EndIf

'    DS1307_WriteTime(20, 57, 00, ReturnACK)     ' Write an initial time
'    If ReturnACK = 1 Then
'        HRSOut "NACK DS1307 Write Time", CR
'    EndIf
'-------------------------------------------------------------------------------
    ' Check if the 24LC256 eeprom memory is connected?
    MyDevice = 0
    M24LC256_Present(MyDevice, ReturnACK)    
    If ReturnACK = 0 Then
        HRSOut "The 24LC256 device is ready!", CR
    Else
        HRSOut "NACK 24LC256 Device", CR
        Stop        ' The program demo cannot run.
    EndIf
 '-------------------------------------------------------------------------------
    HRSOut CR
    $ifdef _LCD_
    High LCD_Backlight              ' Set the Backlight to see the value on the LCD.
    $endif
    MinuteCounter = 0
    E2P_PageList = 0
    E2P_Page = 0
    RTC_Minute_Old = 0
'===============================================================================
' MAIN program: Read the Time every second & Read the date every minute.
' Set the Backlight On 3 Sec every minute to see the Time & Date on the LCD.
MAIN_LOOP:
    While 1 = 1
        #ifdef WatchDog_Req
        Clrwdt
        #endif 
        DS1307_ReadTime(ReturnACK)                         ' Read the time from the DS1307 every second (more or less).
        If ReturnACK = 1 Then
            HRSOut "NACK DS1307 Read Time", CR
        EndIf
    
        ' Write the Date every minute only
        If RTC_Minute <> RTC_Minute_Old Then
            $ifdef _LCD_
            High LCD_Backlight                             ' Set the Backlight to see the value on the LCD.
            bCounter = 3                                   ' The Backlight is triggered for 3 sec
            $endif
            ' Write the Date to test only
            DS1307_ReadDate(ReturnACK)                     ' Read the date from the DS1307
            If ReturnACK = 1 Then
                HRSOut "NACK DS1307 Read Date", CR
            EndIf
            DS1307_Get_DayName(RTC_DayOfWeek, RTC_DayName) ' Get the day's name into string RTC_DayName
            DS1307_Get_MonthName(RTC_Month, RTC_MonthName) ' Get the months's name into string RTC_MonthName
        
            HRSOut "Date = ", RTC_DayName, " ",_        ' \
                              Dec2 RTC_Day, "/",_       ' | Serially transmit the date as ASCII
                              Dec2 RTC_Month,_          ' |
                              "/20", Dec RTC_Year, CR   ' /
        
            HRSOut "Time = ", Dec2 RTC_Hour, ":",_      ' \
                              Dec2 RTC_Minute, ":",_    ' | Serially transmit the time as ASCII
                              Dec2 RTC_Second, CR       ' /

            RTC_Minute_Old =  RTC_Minute                ' Save the new minute value.
            '-------------------------------------------------------------------
            ' Read (with security) the temperature from the TC74 sensor.
            Temperature = TC74_ReadSeCTemp(SensorAddress, ReturnPolarity, ReturnACK)
            If ReturnACK = 1 Then
                HRSOut "NACK TC74 Read Temperature: There is not any communication with the sensor."
                Stop
            EndIf
            ' Disconnect the temperature sensor to avoid self heating.
            TC74_StandbyMode(SensorAddress, ReturnACK)
            If ReturnACK = 1 Then
                HRSOut "NACK TC74 StandbyMode: There is not any communication with the sensor."
                Stop
            EndIf
            ' Send the temperature value to the terminal.
            HRSOut "Temperature: "
            If ReturnPolarity = 0 Then          
                HRSOut "+"
            Else                                    
                HRSOut "-"
            EndIf
            HRSOut Dec Temperature, " Degrees C", CR
            '
            ' The calculation of the Humidity is only for testing the eeprom because there is not a sensor.
            Humidity = Abs OrgTemperature
            Humidity = Humidity * 3 / 2     ' Simulation of the Humidity value.
            HRSOut "Humidity: ", Dec Humidity, "%", CR         
            '-------------------------------------------------------------------
            HRSOut "Writing E2P... Device: ", Dec MyDevice, " Page: ", Dec E2P_Page, CR
            HRSOut CR

            ' Load the original temperature format into the DS1307 array.
            ' The OrgTemperature is loaded by the TC74_ReadSeCTemp() command.
            ' Format the DS1307 array to the ListArray for the 24LC256 memory.
            ' Byte1: First variable to save (Humidity). Byte2: 2nd Variable To Save (OrgTemperature).
            DS1307_ZipPage8(Humidity,OrgTemperature)    ' Zip the Clock/Datye/Datas to E2PArray.                               

            ' Write a page from the DS1307/TC74 datas to the 24C256 eeprom memory.
            ' Writing 1 page of 8 bytes to the eeprom 24LC256.
            ' MyDevice: Number of the Memory device (8 Max). In this demo, the 1st device (number 0) is used only.
            ' E2PArray: Array where the datas are loaded. (generated by the DS1307 library)
            ' E2P_Page: Number of memory page to write.
            ' ReturnACK: ACK control = 0 => OK  
            ' With the AMicus18 board only one memory is avaible.
            WritePage_E2P8(MyDevice, E2PArray, E2P_Page, ReturnACK)
            If ReturnACK = 1 Then
                HRSOut "NACK 24C256 write"
             EndIf
            LastE2P_Page = E2P_Page         ' Save the current Page.
            Inc E2P_Page                    ' Next page to write (every 8 Bytes).            
            E2P_Page = E2P_Page & $0FFF     ' 32 KBytes only (4096 pages of 8 bits)
            '-------------------------------------------------------------------
            ' Counter to stop the data looger & go to read the eeprom memory.
            Inc MinuteCounter
            If MinuteCounter = 5 Then   ' Number of memory pages to write.
                MinuteCounter = 0
                Break                   ' Goto read & print the eeprom memory data. 
            EndIf
        EndIf
        '-----------------------------------------------------------------------
        ' Print the Date to the LCD every second.
        $ifdef _LCD_
        CLL(1)                                          ' Erase line 1 of the LCD
        Print At 1,1, Str RTC_DayName\5, " ", Dec2 RTC_Day, "/", Dec2 RTC_Month, "/20", Dec RTC_Year
        ' Print the Time to the LCD every second.
        CLL(2)                                          ' Erase line 2 of the LCD
        Print At 2,1, Dec2 RTC_Hour, ":", Dec2 RTC_Minute, ":", Dec2 RTC_Second    
        GoSub PrintTemperatureLine2_Sub
        $endif    
        '-----------------------------------------------------------------------
        ' Delay for the Backlight (3 Sec).
        $ifdef _LCD_
        If bCounter > 0 Then                
            Dec bCounter            ' Decrement the Backlight counter every second.
            If bCounter = 0 Then
                Low LCD_Backlight
            EndIf
        EndIf    
        $endif
        DelayMS 998                 ' 1 second timing for the loop.
    Wend
'-------------------------------------------------------------------------------
' Number of pages for the 24C256.
' eeprom memory: 32768KB / 8  = 4096 pages of 8 bytes (This demo)
' eeprom memory: 32768KB / 64 =  512 pages of 64 bytes
'
' Read the last 5 pages of the external eeprom memory.
    HRSOut "Reading the 5 last pages written in the 24LC256 eeprom memory", CR
    MyDeviceList = 0                            ' Number of the memory device to read (always one memory only).        
    Repeat
        GoSub PrintListToTerminalPage8_Sub
        Inc E2P_PageList                        ' Next page to read.
        E2P_PageList = E2P_PageList & $0FFF     ' 32K Bytes only.
    Until E2P_PageList > LastE2P_Page           ' Read until the last page written into the eeprom.
    HRSOut CR

    GoTo MAIN_LOOP                              ' Come back to the Data Logger.
'===============================================================================
'===============================================================================
' SUBROUTINES:
'-------------------------------------------------------------------------------
' Read Datas from eeprom memory a 8 Bits Page and print them to the terminal.
PrintListToTerminalPage8_Sub:
    ' MyDeviceList: Number of the Memory device to read (8 Max). In this demo, the 1st Device (number 0) is used only.
    ' E2PArray: Array where the memory is restored.
    ' E2P_PageList: Number of memory page to read.
    ' ReturnACK: ACK control = 0 => OK    
    ReadPage_E2P8(MyDeviceList, E2PArray, E2P_PageList, ReturnACK)
    If ReturnACK = 1 Then
        HRSOut "NACK 24C256 read"
    EndIf    

    ' Unzip the Time & Date restored from the eeprom memory.
    ' Humidity: 1st data value restored from the eeprom memory.
    ' Temperature: 2nd data value restored from the eeprom memory.    
    DS1307_UnZipPage8(Humidity, Temperature)    ' Reformat the DS1307 RTC to the standard array.
    '---------------------------------------------------------------------------
    ' Send to terminal some datas read from the eeprom memory.
    HRSOut "D", Dec MyDeviceList, " P", Dec E2P_PageList, " "
    DS1307_Get_DayName(vRTC_DayOfWeek, RTC_DayName) ' Get the day's name into string RTC_DayName
    HRSOut RTC_DayName, ": ", Dec2 vRTC_Day, "/", Dec2 vRTC_Month, "/20", Dec vRTC_Year, " / "
    HRSOut Dec2 vRTC_Hour, ":", Dec2 vRTC_Minute, ":", Dec2 vRTC_Second, " / "
    HRSOut "Temperature: " 
    ' The temperature value is the TC74 format.
    If Temperature.7 = 1 Then          
        Temperature = ~Temperature    
        Inc Temperature
        HRSOut "-"
    Else                                    
        HRSOut "+"
    EndIf
    ' Send the temperature + Humidity to the terminal.
    HRSOut Dec Temperature : HRSOut " C"
    HRSOut " / Humidity: ", Dec Humidity, "%", CR 
    Return
'-------------------------------------------------------------------------------
' Print the temperature to the LCD at Line 2.
$ifdef _LCD_
PrintTemperatureLine2_Sub:
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
    If Temperature < 10 Then
        nCharPos = 13
    ElseIf Temperature > 99 Then
        nCharPos = 11
    Else
        nCharPos = 12
    EndIf        
    CLL(2,11)                       ' Delete characters 11 to 16 in line 2.
    Cursor 2,nCharPos    
    If ReturnPolarity = 0 Then
        Print "+"
    Else
        Print "-"
    EndIf
    Print Dec Temperature, $DF, "C" ' Print temperature and C to the LCD.
    Return
$endif       
'===============================================================================
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
$ifdef _HRSOutVersionFile_inc_
_Test1_DS1307_bas_Version: CData "Test2_DS1307.bas Version 1.0 - 15/03/2016",0
$endif
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
    
